-- create a function that returns the department that has more employees
SET SERVEROUTPUT ON;

CREATE OR REPLACE FUNCTION department_top RETURN NUMBER IS
	l_deptno   emp.deptno%TYPE;
	l_num      NUMBER;
BEGIN
	SELECT deptno, num INTO l_deptno, l_num
	FROM (
			SELECT deptno, COUNT(*) AS num
			FROM emp
			GROUP BY deptno
			ORDER BY COUNT(*) DESC )
	WHERE ROWNUM <=1;
	RETURN l_deptno; 
END;
/

SHOW ERRORS;
------------------------------------------------------------
--Call the function inside a select statement
SELECT department_top FROM DUAL;
------------------------------------------------------------
--Call the function inside an anonymous PL/SQL block
SET SERVEROUTPUT ON;

DECLARE
	l_dept NUMBER;
BEGIN
	l_dept := department_top;
	DBMS_OUTPUT.PUT_LINE(l_dept);
END;
/

-----------------------------------
SET SERVEROUTPUT ON;
BEGIN
	DBMS_OUTPUT.PUT_LINE(department_top);
END;
