-- create procedure with several exceptions treated
SET SERVEROUTPUT ON;

CREATE OR REPLACE PROCEDURE get_salary_exception (x VARCHAR2) IS
	--Return the salary of as employee whose his number is received as a parameter
	--Allows to test Exception
	--The query used in this procedure is a bad solution for this problem because it can 
	--   return several lines, 1 line or none
	--The errors caused by the select statement are treated by several exceptions
	w_emp employees%ROWTYPE;
BEGIN
	SELECT * INTO w_emp FROM employees WHERE first_name LIKE x;
	DBMS_OUTPUT.PUT_LINE(w_emp.first_name||'-'||w_emp.last_name||'-'||w_emp.salary);
	DBMS_OUTPUT.PUT_LINE('===========================================================');
EXCEPTION
	WHEN NO_DATA_FOUND THEN
		DBMS_OUTPUT.PUT_LINE('No rows returned with this search criteria');
		DBMS_OUTPUT.PUT_LINE('Error on Select = '||substr(rtrim(sqlerrm),1,1000));
		DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------------');
	WHEN TOO_MANY_ROWS THEN
		DBMS_OUTPUT.PUT_LINE('Select returns more than one row');
		DBMS_OUTPUT.PUT_LINE('Error on select = '||substr(rtrim(sqlerrm),1,1000));
		DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------------');
	WHEN OTHERS THEN
		DBMS_OUTPUT.PUT_LINE('Error with no pre-defined exception');
		DBMS_OUTPUT.PUT_LINE('Error on SELECT = '||substr(rtrim(sqlerrm),1,1000));
		DBMS_OUTPUT.PUT_LINE('-----------------------------------------------------------');
END;
/

--------------------------------------
SHOW ERRORS;
SET SERVEROUTPUT ON;

--------------------------------------
BEGIN
  get_salary_exception('Hazel'); --Runs ok because the query returns one row
  get_salary_exception('xpto');  --The query returns no rows, so an error is raised
  get_salary_exception('%');     --Force an error with no pre-defined exception
END;
/
