-- PLSQL nested blocks
-- This example shows a PL/SQL block inside another block.
-- The exception raised in the inner block is treated in that block 
SET SERVEROUTPUT ON;

DECLARE
	l_empno  emp.empno%TYPE;
	l_ename  emp.ename%TYPE;
	l_mensagem VARCHAR2(100);
BEGIN
	l_empno := $[?read_empno];
	BEGIN
		SELECT ename INTO l_ename FROM emp WHERE empno=l_empno;
	EXCEPTION
		WHEN TOO_MANY_ROWS THEN
			l_mensagem := 'too many rows';
		WHEN NO_DATA_FOUND THEN
			l_mensagem := 'no_data_found';
		WHEN OTHERS THEN
			l_mensagem := 'others';
    END;
	IF l_ename IS NULL THEN
		DBMS_OUTPUT.PUT_LINE(l_mensagem);
	END IF;	
END;
/
