-- This procedure shows the source code of a PL/SQL element
SET SERVEROUTPUT ON;

CREATE OR REPLACE PROCEDURE show_code(p_owner VARCHAR2, p_type VARCHAR2, p_name VARCHAR2) IS
	CURSOR c_list(cp_owner VARCHAR2, cp_type VARCHAR2, cp_name VARCHAR2) IS 
		SELECT 'CREATE OR REPLACE '|| text as text, LINE
			FROM all_source
			WHERE owner = cp_owner
			AND type = cp_type
			AND name = cp_name
			AND line = 1
			UNION ALL
			SELECT text, line
			FROM all_source
			WHERE type = cp_type
			AND owner = cp_owner
			AND name = cp_name
			AND line > 1
			ORDER BY line;
BEGIN
	FOR l_line IN c_list(p_owner, p_type, p_name) LOOP
		DBMS_OUTPUT.PUT_LINE(l_line.text);
	END LOOP;
END;
/

SHOW ERRORS;

BEGIN
  show_code('HR','PROCEDURE','SHOW_CODE');
END;
/

